;; Functions for list operations

(define friends (list 'Niki
                      'Vale
                      'Robb
                      'Matt))

;;----------------------------
;; Search
;;----------------------------

(define (search-list afriend alist)
  (cond
    [(empty? alist) false]
    [else
     (cond
       [(symbol=? afriend (first alist)) true]
       [else (search-list afriend (rest alist))])]))

;;----------------------------
;; Delete
;;----------------------------

(define (delete-list afriend alist)
  (cond
    [(empty? alist) empty]
    [(symbol=? afriend (first alist)) (delete-list afriend (rest alist))]
    [else (cons (first alist) (delete-list afriend (rest alist)))]))

;;----------------------------
;; Insert after a given node
;;----------------------------

(define (add-list newentry afriend alist)
  (cond
    [(empty? alist) empty]
    [(symbol=? afriend (first alist)) (cons afriend (cons newentry (add-list newentry afriend (rest alist))))]
    [else (cons (first alist) (add-list newentry afriend (rest alist)))]))

;;----------------------------
;; Substitute
;;----------------------------

(define (subst-list newentry oldfriend alist)
  (cond
    [(empty? alist) empty]
    [(symbol=? oldfriend (first alist)) (cons newentry (subst-list newentry oldfriend (rest alist)))]
    [else (cons (first alist) (subst-list newentry oldfriend (rest alist)))]))